<?php

/**
 * @file commerce_spgateway.admin.inc
 * 
 */

function commerce_spgateway_settings_form($form, &$form_state){
    $form['spgatewayStatus']=array(
        '#type' => 'radios',
        '#title'=> '智付通系統狀態',
        '#description'=> '選擇對應的系統狀態。例如：測試環境、正式環境',
        '#options' => array(
            'dev' => '測試環境',
            'production' => '正式環境',
        ),
        '#default_value' => variable_get('spgatewayStatus','dev'),
        '#required' => TRUE,
        '#weight'=>0,
    );

    $form['spgatewayMerchantID'] = array(
        '#type'=>'textfield',
        '#title'=>'MerchantID',
        '#description'=>'智付通MerchantID，需要經過申請才會有此ID，測試環境也需要申請',
        '#maxlength' => 255,
        '#size' => 30,
        '#required' => TRUE,
        '#default_value' => variable_get('spgatewayMerchantID','MS35530184'),
        '#weight'=>1,
    );

    $form['spgatewayHashKey'] = array(
        '#type'=>'textfield',
        '#title'=>'HashKey',
        '#description'=>'智付通HashKey，需要經過申請才會有此ID，測試環境也需要申請',
        '#maxlength' => 255,
        '#size' => 30,
        '#required' => TRUE,
        '#default_value' => variable_get('spgatewayHashKey','K6PnjLnDPphKLc5ABLLEwKyz63DdFSW1'),
        '#weight'=>2,
    );

    $form['spgatewayHashIV'] = array(
        '#type'=>'textfield',
        '#title'=>'HashIV',
        '#description'=> '智付通HashIV，需要經過申請才會有此ID，測試環境也需要申請',
        '#maxlength' => 255,
        '#size' => 30,
        '#required' => TRUE,
        '#default_value' => variable_get('spgatewayHashIV','HxUZxqAe6uUaOO4Z'),
        '#weight'=>3,
    );

    $form['spgatewayItemDesc'] = array(
        '#type'=>'textfield',
        '#title'=>'商品資訊',
        '#description'=> '長度50字，請勿使用特殊字元，並且使用Utf-8編碼方式',
        '#maxlength' => 50,
        '#size' => 30,
        '#required' => TRUE,
        '#default_value' => variable_get('spgatewayItemDesc','使用HelloSanta模組購買商品'),
        '#weight'=>4,
    );

    $form['spgatewayOrderComment'] = array(
        '#type'=>'textarea',
        '#title'=>'商店備註',
        '#description'=> '1.限制長度為 300 字。2.若有提供此參數，將會於 MPG 頁面呈現商店備註內容。',
        '#maxlength' => 300,
        '#default_value' => variable_get('spgatewayOrderComment'),
        '#weight'=>5,
    );

    $form['spgatewayEmailModify'] = array(
        '#type'=>'radios',
        '#title'=>'付款人電子信箱是否開放修改',
        '#description'=> '設定於 MPG 頁面，付款人電子信箱欄位是否開放讓付款人修改',
        '#options' => array(
            1 => '可修改',
            0 => '不可修改',
        ),
        '#default_value' => variable_get('spgatewayEmailModify',0),
        '#weight'=>6,
    );

    $form['spgatewayLoginType'] = array(
        '#type'=>'radios',
        '#title'=>'智付通會員',
        '#description'=> '是否需要是會員才能使用金流',
        '#options' => array(
            1 => '須要登入智付通會員',
            0 => '不須登入智付通會員',
        ),
        '#default_value' => variable_get('spgatewayLoginType',0),
        '#weight'=>7,
    );

    $form['submit']=array(
        '#type'=>'submit',
        '#weight'=>10,
        '#value'=> '儲存',
    );
    return $form;
}

function commerce_spgateway_settings_form_submit($form,&$form_state){

    $spgatewayStatus = $form_state['values']['spgatewayStatus'];
    $spgatewayMerchantID = $form_state['values']['spgatewayMerchantID'];
    $spgatewayHashKey = $form_state['values']['spgatewayHashKey'];
    $spgatewayHashIV = $form_state['values']['spgatewayHashIV'];
    $spgatewayItemDesc = $form_state['values']['spgatewayItemDesc'];
    $spgatewayOrderComment = $form_state['values']['spgatewayOrderComment'];
    $spgatewayEmailModify = $form_state['values']['spgatewayEmailModify'];
    $spgatewayLoginType = $form_state['values']['spgatewayLoginType'];

    variable_set('spgatewayStatus',$spgatewayStatus);
    variable_set('spgatewayMerchantID',$spgatewayMerchantID);
    variable_set('spgatewayHashKey',$spgatewayHashKey);
    variable_set('spgatewayHashIV',$spgatewayHashIV);
    variable_set('spgatewayItemDesc',$spgatewayItemDesc);
    variable_set('spgatewayOrderComment',$spgatewayOrderComment);
    variable_set('spgatewayEmailModify',$spgatewayEmailModify);
    variable_set('spgatewayLoginType',$spgatewayLoginType);

    drupal_set_message('修改更新成功');
}