<?php

/**
 * @file commerce_spgateway_cvs.inc
 * 主要來處理超商代碼繳費
 */

/**
 * Implements CALLBACK_commerce_payment_method_settings_form
 */

 function spgateway_cvs_settings_form($settings = NULL){
    
    for($i=1;$i <= 180;$i++){
      $expiredate_option[$i]=$i;
    }
    $form = array();


    $form['ExpireDate'] = array(
        '#type' => 'select',
        '#title' => '繳費有效期限',
        '#description' => '可接受最大值為180天',
        '#options' => $expiredate_option,
        '#default_value' => empty($settings['ExpireDate'])?'7':$settings['ExpireDate'],
    );

    return $form;
 }

/**
 * Implements CALLBACK_commerce_payment_method_redirect_form
 */
function spgateway_cvs_redirect_form($form, &$form_state, $order, $payment_method) {
    
    global $base_url;
    

    //基本參數
    $ActionURL = SPGATEWAY_POST_SERVICE_URL;

    //交易資訊
    $remote_id=date('YmdHis').$order->order_id;
    $Amount=$order->commerce_order_total['und'][0]['amount'];
    $price = commerce_currency_amount_to_decimal($Amount, 'TWD');
    $mail = $order->mail;
    $ItemDesc = variable_get('spgatewayItemDesc','使用HelloSanta模組購買商品');

    //時間限制
    $TradeLimit = ''; //不適用在非即時
    $ExpireDate = isset($payment_method['settings']['ExpireDate'])?$payment_method['settings']['ExpireDate']:7; //適用在非即時

    //傳送Data
    $data = array(
        'MerchantID' => variable_get('spgatewayMerchantID','MS35530184'),
        'TradeInfo' => '',
        'TradeSha' => '',
        'Version' => '1.5',
        'RespondType' => 'JSON',
        'TimeStamp' => REQUEST_TIME,
        'LangType' => 'zh-tw',
        'MerchantOrderNo'=> $remote_id,
        'Amt' => $price,
        'ItemDesc' => $ItemDesc,
        'TradeLimit'=> $TradeLimit,
        'ExpireDate' => date("Ymd" , mktime(0,0,0,date("m"),date("d")+$ExpireDate,date("Y"))), //非適用即時交易
        'ReturnURL' => $base_url.'/checkout/'.$order->order_id,
        'NotifyURL' => $base_url.'/checkout/'.$order->order_id.'/spgateway-notify',
        'CustomerURL' => $base_url.'/checkout/'.$order->order_id.'/spgateway-backpayment', //非即時交易支付方式
        'ClientBackURL' => $base_url.'/checkout/'.$order->order_id,
        'Email' => $mail,
        'EmailModify' => variable_get('spgatewayEmailModify',0), //不開放付款人電子郵件修改
        'LoginType' => variable_get('spgatewayLoginType',0), //不需要登入智付通會員
        'OrderComment' => variable_get('spgatewayOrderComment'),
        //以下開始是付款方式的參數
        'CREDIT' => 0,
        'ANDROIDPAY' => 0,
        'SAMSUNGPAY' => 0,
        'InstFlag' => 0,
        'CreditRed' => 0,
        'UNIONPAY' => 0,
        'WEBATM' => 0,
        'VACC' => 0,
        'CVS' => 1,
        'BARCODE' => 0,
        'P2G' => 0,
        'CVSCOM' => 0,
    );

    //加密資料
    $encrydata = spgateway_transaction_encrypt($data);
    $TradeInfo = $encrydata['TradeInfo'];
    $TradeSha = $encrydata['TradeSha'];

    $data['TradeInfo'] = $TradeInfo;
    $data['TradeSha'] = $TradeSha;

    foreach ($data as $name => $value) {
        if (!empty($value)) {
           $form[$name] = array('#type' => 'hidden', '#value' => $value);
        }
    }  
  
    $form['#action'] = $ActionURL;
    $form['submit'] = array(
        '#type' => 'submit',
        '#value' => t('Go'),
    );

    //建立交易記錄
    commerce_spgateway_create_payment_transactions($remote_id, $order, $payment_method, COMMERCE_PAYMENT_STATUS_PENDING);

    return $form;
}